const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const medication_doses = sequelize.define(
    'medication_doses',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

scheduled_time: {
        type: DataTypes.DATE,
      
      

      },

taken_time: {
        type: DataTypes.DATE,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"scheduled",


"taken",


"missed",


"skipped"

        ],

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  medication_doses.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















































































































//end loop



    db.medication_doses.belongsTo(db.medications, {
      as: 'medication',
      foreignKey: {
        name: 'medicationId',
      },
      constraints: false,
    });




    db.medication_doses.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.medication_doses.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return medication_doses;
};


